<template>
  <div>
    <p class="h3">Categories</p>
    <b-list-group class="overflow-hidden">
      <b-list-group-item
        v-for="category in categories"
        :key="category.id"
        class="p-relative"
        :class="{
          'bg-light': selectedCategories[category.id],
        }"
        @click="toggleCategory(category.id)"
      >
        <span
          class="categoryColor"
          :style="{
            backgroundColor: category.color,
          }"
        ></span>
        {{ category.name }}
      </b-list-group-item>
    </b-list-group>
  </div>
</template>

<style lang="scss">
.categoryColor {
  position: absolute;
  left: 0;
  top: 0;
  bottom: 0;
  width: 5px;
}
</style>

<script>
import categoryQuery from '@/graphql/category.query';

export default {
  data: () => ({
    selectedCategories: {},
  }),
  apollo: {
    categories: categoryQuery,
  },
  methods: {
    toggleCategory(id) {
      this.selectedCategories = { ...this.selectedCategories, [id]: !this.selectedCategories[id] };
      this.$emit(
        'categoriesChanged',
        Object.keys(this.selectedCategories)
          .filter(k => this.selectedCategories[k])
          .map(i => +i),
      );
    },
  },
};
</script>
